#cloud-config
# vim: syntax=yaml

ssh_pwauth: true

# add non privileged user for later ansible runs
users:
  - name: sysadm
    ssh_authorized_keys:
      - ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIPHUuPrbu9kSKL1u0gfViSa/P7FkZPk8hYbv7hegpTcY bodo@boone-schulz.de
      - ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIG3/Vt8RKhgN99v6FJ1T13so0Bc6Tq1FkoTC1YAQ4zLK bodo.schulz@bitgrip.de
    sudo: ['ALL=(ALL) NOPASSWD:ALL']
    shell: /bin/bash
    groups: admin
    password: "$6$fdfngmklndfgbl$fhdX3uCUIwHdeiGk4/tbmR50q5UCGdHPckqn0HX9vBLEwc2hh8CWAE4ryawvQF.WDKb60O.uJCdPhTTxzxSUX/"

  - name: ansible
    ssh_authorized_keys:
      - ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIPHUuPrbu9kSKL1u0gfViSa/P7FkZPk8hYbv7hegpTcY bodo@boone-schulz.de
      - ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIG3/Vt8RKhgN99v6FJ1T13so0Bc6Tq1FkoTC1YAQ4zLK bodo.schulz@bitgrip.de
    sudo: ['ALL=(ALL) NOPASSWD:ALL']
    shell: /bin/bash
    groups: users,admin,wheel,sudo
    password: "$6$fdfngmklndfgbl$H6Z6MdP23KTogsA01.pjmVueKqkeL/vGLM.KAhDC14u6gTwOfCGA9PQBQigiRtywiPhMC5MDx6b56WGPagUIU."

# root user should be available
disable_root: false

# change some passwords
#
# - create password:
#   makepasswd --minchars 20 --maxchars 20
# - hash the generated passwort with openssl:
#   (Note: passing -1 will generate an MD5 password, -5 a SHA256 and -6 SHA512 (recommened))
#   openssl passwd -6 -salt fdfngmklndfgbl   PASSWORD
chpasswd:
  expire: False
  users:
    - name: root
      password: "$6$fdfngmklndfgbl$fhdX3uCUIwHdeiGk4/tbmR50q5UCGdHPckqn0HX9vBLEwc2hh8CWAE4ryawvQF.WDKb60O.uJCdPhTTxzxSUX/"
    - name: sysadm
      password: "$6$fdfngmklndfgbl$fhdX3uCUIwHdeiGk4/tbmR50q5UCGdHPckqn0HX9vBLEwc2hh8CWAE4ryawvQF.WDKb60O.uJCdPhTTxzxSUX/"
    - name: ansible
      password: "$6$fdfngmklndfgbl$H6Z6MdP23KTogsA01.pjmVueKqkeL/vGLM.KAhDC14u6gTwOfCGA9PQBQigiRtywiPhMC5MDx6b56WGPagUIU."

# https://cloudinit.readthedocs.io/en/latest/topics/examples.html#grow-partitions
growpart:
  mode: auto
  devices: ['/']

# # First, repo_update and repo_upgrade will update the repository and upgrade all packages respectively.
# # Note that this only occurs once on the first boot.
repo_update: true
repo_upgrade: all

# # Run apt or yum upgrade
# # https://cloudinit.readthedocs.io/en/latest/topics/examples.html#update-apt-database-on-first-boot
package_update: true
# # https://cloudinit.readthedocs.io/en/latest/topics/examples.html#run-apt-or-yum-upgrade
package_upgrade: true

# Install arbitrary packages
# https://cloudinit.readthedocs.io/en/latest/topics/examples.html#install-arbitrary-packages
packages:
  - bash-completion
  - nano
  - qemu-guest-agent
  - libvirt-clients
  - python3
  - htop
  - tree
  - dnsmasq
  - haveged
  - kbd
  # - console-setup-mini

runcmd:
  - rm -f /etc/resolv.conf
  - echo "nameserver 141.1.1.1" | sudo tee /etc/resolv.conf
  - echo "net.ipv6.conf.all.disable_ipv6 = 1" | sudo tee /etc/sysctl.d/10-disable-ipv6.conf
  - echo "" > /etc/network/interfaces.d/50-cloud-init.cfg
  - systemctl restart ssh.service
  - systemctl restart haveged
  - systemctl enable haveged
  - systemctl stop snapd
  - systemctl stop snapd.socket
  - systemctl disable snapd
  - systemctl disable snapd.socket
  - apt purge -y snapd

# test of writing content
write_files:
  - path: "/etc/vconsole.conf"
    permissions: '0644'
    content: |
      KEYMAP=de-latin1-nodeadkeys
      FONT="ter-v32b"

  - path: "/etc/network/interfaces"
    permissions: '0644'
    content: |
        source /etc/network/interfaces.d/*

        auto lo
        iface lo inet loopback

        dns-nameservers ${prefixIP}.1 141.1.1.1

  - path: /etc/network/interfaces.d/eth0
    content: |
        auto eth0
        iface eth0 inet static
          address ${prefixIP}.${octetIP}
          netmask 255.255.255.0
          gateway ${prefixIP}.1
          dns-nameservers ${prefixIP}.1 141.1.1.1
          dns-search ${domain}
          #  hwaddress ether
        auto ens3
        iface ens3 inet static
          address ${prefixIP}.${octetIP}
          netmask 255.255.255.0
          gateway ${prefixIP}.1
          dns-nameservers ${prefixIP}.1 141.1.1.1
          dns-search ${domain}

#   - path: /etc/default/console-setup
#     content: |
#           ACTIVE_CONSOLES="/dev/tty[1-6]"
#           CHARMAP="UTF-8"
#           CODESET="guess"
#           FONTFACE="TerminusBold"
#           FONTSIZE="16x32"
#           SCREEN_WIDTH="80"


# written to /var/log/cloud-init-output.log
final_message: "The system is finall up, after $UPTIME seconds"


power_state:
  mode: reboot
  message: rebooting
  timeout: 10
  condition: True
